Index: /extensions/PiwigoLib/PiwigoLib/Proxy/Response/PwgCategoriesProxyResponse.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoLib/Proxy/Response/PwgCategoriesProxyResponse.cs	(revision 12261)
+++ /extensions/PiwigoLib/PiwigoLib/Proxy/Response/PwgCategoriesProxyResponse.cs	(revision 12262)
@@ -8,4 +8,39 @@
 namespace Com.Piwigo.Lib.Proxy.Response
 {
+    //todo : admin list deifferent !!!!
+//    <rsp stat="ok">
+//<categories>
+//    <category id="1" nb_images="34" total_nb_images="34" date_last="2011-04-12 00:39:03" max_date_last="2011-04-12 00:39:03" nb_categories="1" url="http://photo.bayral.fr/index.php?/category/1">
+//        <name>2011 01 02 Dimanche au Ski</name>
+//        <uppercats>1</uppercats>
+//        <global_rank>1</global_rank>
+//        <comment></comment></category>
+//    <category id="12" nb_images="0" total_nb_images="0" nb_categories="0" url="http://photo.bayral.fr/index.php?/category/12">
+//        <name>test</name>
+//        <uppercats>1,12</uppercats>
+//        <global_rank>1.1</global_rank>
+//        <id_uppercat>1</id_uppercat>
+//        <comment></comment></category>
+//    <category id="2" nb_images="8" total_nb_images="8" date_last="2011-04-12 00:52:41" max_date_last="2011-04-12 00:52:41" nb_categories="0" url="http://photo.bayral.fr/index.php?/category/2">
+//        <name>2010 12 Photos Noé Loic</name>
+//        <uppercats>2</uppercats>
+//        <global_rank>2</global_rank>
+//        <comment></comment></category>
+//    <category id="3" nb_images="99" total_nb_images="99" date_last="2011-04-12 23:59:28" max_date_last="2011-04-12 23:59:28" nb_categories="0" url="http://photo.bayral.fr/index.php?/category/3">
+//        <name>2010 12 24-25 Noel</name>
+//        <uppercats>3</uppercats>
+//        <global_rank>3</global_rank>
+//        <comment></comment></category>
+//    <category id="5" nb_images="14" total_nb_images="14" date_last="2011-04-13 00:13:06" max_date_last="2011-04-13 00:13:06" nb_categories="0" url="http://photo.bayral.fr/index.php?/category/5">
+//        <name>2010 11 Photos Noé Loic</name>
+//        <uppercats>5</uppercats>
+//        <global_rank>4</global_rank>
+//        <comment></comment></category>
+//    <category id="6" nb_images="45" total_nb_images="45" date_last="2011-04-13 22:59:49" max_date_last="2011-04-13 22:59:49" nb_categories="0" url="http://photo.bayral.fr/index.php?/category/6">
+//        <name>2010 11 23 28 aniversaire Noé 4 ans Famille</name>
+//        <uppercats>6</uppercats>
+//        <global_rank>5</global_rank>
+//        <comment></comment></category></categories>
+//</rsp>
     [Serializable()]
     [XmlRoot(ElementName = "category")]
Index: /extensions/PiwigoLib/PiwigoUpload/DTO/LocalAlbumList.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/DTO/LocalAlbumList.cs	(revision 12262)
+++ /extensions/PiwigoLib/PiwigoUpload/DTO/LocalAlbumList.cs	(revision 12262)
@@ -0,0 +1,70 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.ComponentModel;
+
+namespace Com.Piwigo.Uploader.DTO
+{
+    public class LocalAlbumList : BindingList<LocalAlbum>
+    {}
+
+    public class LocalAlbum
+    {
+        private Int32? _id;
+        public Int32? Id
+        {
+            set { _id = value; OnPropertyChanged("Id"); }
+            get { return _id; }
+        }
+
+        private String _messageInfo;
+        public String MessageInfo
+        {
+            set { _messageInfo = value; OnPropertyChanged("MessageInfo"); }
+            get { return _messageInfo; }
+        }
+
+        private String _name;
+        public String Name
+        {
+            set { _name = value; OnPropertyChanged("Name"); }
+            get { return _name; }
+        }
+
+        private String _localDir;
+        public String LocalDir
+        {
+            set { _localDir = value; OnPropertyChanged("LocalDir"); }
+            get { return _localDir; }
+        }
+
+        private Int32? _upperCatId;
+        public Int32? UpperCatId
+        {
+            set { _upperCatId = value; OnPropertyChanged("UpperCatId"); }
+            get { return _upperCatId; }
+        }
+
+        private LocalAlbumList _subAlbums;
+        public LocalAlbumList SubAlbums
+        {
+            set { _subAlbums = value; OnPropertyChanged("SubAlbums"); }
+            get { return _subAlbums; }
+        }
+
+        private LocalImageList _localImages;
+        public LocalImageList LocalImages
+        {
+            set { _localImages = value; OnPropertyChanged("LocalImages"); }
+            get { return _localImages; }
+        }
+
+        public event PropertyChangedEventHandler PropertyChanged;
+        protected void OnPropertyChanged(String info)
+        {
+            if (PropertyChanged != null)
+                PropertyChanged(this, new PropertyChangedEventArgs(info));
+        }
+    }
+}
Index: /extensions/PiwigoLib/PiwigoUpload/DTO/LocalPwgImage.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/DTO/LocalPwgImage.cs	(revision 12262)
+++ /extensions/PiwigoLib/PiwigoUpload/DTO/LocalPwgImage.cs	(revision 12262)
@@ -0,0 +1,76 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.ComponentModel;
+using Com.Piwigo.Lib.DTO;
+
+namespace Com.Piwigo.Uploader.DTO
+{
+    public class LocalImageList : BindingList<LocalImage>
+    {}
+
+    public class LocalImage
+    {
+        //FileInfo highResFile, FileInfo lowResFile, FileInfo thumbFile, String imageName, String imageAuthor, DateTime creationDate,
+        //    String authorComment, List<String> lstCategories, List<String> lstTags, PwgConfidentLevelEnum? confidentLevel
+
+        private Int32 _id;
+        public Int32 Id
+        {
+            set { _id = value; OnPropertyChanged("Id"); }
+            get { return _id; }
+        }
+
+        private String _authorComment;
+        public String AuthorComment
+        {
+            set { _authorComment = value; OnPropertyChanged("AuthorComment"); }
+            get { return _authorComment; }
+        }
+
+        private String _name;
+        public String Name
+        {
+            set { _name = value; OnPropertyChanged("Name"); }
+            get { return _name; }
+        }
+
+        private String _localFile;
+        public String LocalFile
+        {
+            set { _localFile = value; OnPropertyChanged("LocalFile"); }
+            get { return _localFile; }
+        }
+
+        private Int32 _upperCatId;
+        public Int32 UpperCatId
+        {
+            set { _upperCatId = value; OnPropertyChanged("UpperCatId"); }
+            get { return _upperCatId; }
+        }
+
+        private BindingList<PwgTag> _lstTags;
+        public BindingList<PwgTag> LstTags
+        {
+            set { _lstTags = value; OnPropertyChanged("LstTags"); }
+            get { return _lstTags; }
+        }
+
+        private PwgConfidentLevelEnum _confidentialLevel;
+        public PwgConfidentLevelEnum ConfidentialLevel
+        {
+            set { _confidentialLevel = value; OnPropertyChanged("ConfidentialLevel"); }
+            get { return _confidentialLevel; }
+        }
+
+        public event PropertyChangedEventHandler PropertyChanged;
+        protected void OnPropertyChanged(String info)
+        {
+            if (PropertyChanged != null)
+                PropertyChanged(this, new PropertyChangedEventArgs(info));
+        }
+
+
+    }
+}
Index: /extensions/PiwigoLib/PiwigoUpload/DTO/ModelManager.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/DTO/ModelManager.cs	(revision 12261)
+++ /extensions/PiwigoLib/PiwigoUpload/DTO/ModelManager.cs	(revision 12262)
@@ -29,4 +29,6 @@
             public PwgSession sess { get; set; }
             public SelectedPwgCategoryList lstCat { get; set; }
+            public Int32 PwgCategoryIdSelected { get; set; }
+            public LocalAlbumList lstAlbumLocaux { get; set; }
             public Boolean isConnected { get; set; }
             public String directoryName { get; set; }
@@ -34,4 +36,24 @@
             public String userName { get; set; }
             public String password { get; set; }
+
+            public ModelManagerBase()
+            {
+                lstCat = new SelectedPwgCategoryList();
+                lstAlbumLocaux = new LocalAlbumList();
+                isConnected = false;
+            }
+
+            internal void resetLstCat()
+            {
+                if (lstCat == null)
+                {
+                    lstCat = new SelectedPwgCategoryList();
+                }
+                else
+                {
+                    lstCat.Clear();
+                }
+                lstCat.Add(new SelectedCategoryListItem() { Id = PwgCategory.RootCategoryId, ShowedValue = "Root album", Data=null, isSelected=true }); 
+            }
         }
     }
Index: /extensions/PiwigoLib/PiwigoUpload/DTO/SelectedList.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/DTO/SelectedList.cs	(revision 12261)
+++ /extensions/PiwigoLib/PiwigoUpload/DTO/SelectedList.cs	(revision 12262)
@@ -1,19 +1,26 @@
 ﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
 using Com.Piwigo.Lib.DTO;
+using System.ComponentModel;
 
 namespace Com.Piwigo.Uploader.DTO
 {
-    public class SelectedListItem<T>
+    public class SelectedListItem<T,Tid>
     {
         public String ShowedValue { get;set;}
-        public object Id          { get;set;}
+        public Tid Id             { get;set;}
         public Boolean isSelected { get;set;}
         public T Data             { get;set;}
+
+        public SelectedListItem()
+        { }
     }
 
-    public class SelectedPwgCategoryList : List<SelectedListItem<PwgCategory>>
+    public sealed class SelectedCategoryListItem : SelectedListItem<PwgCategory, Int32>
+    {        
+        public SelectedCategoryListItem()
+        { }
+    }
+
+    public sealed class SelectedPwgCategoryList : BindingList<SelectedCategoryListItem>
     {        
     }
Index: /extensions/PiwigoLib/PiwigoUpload/Helper/MainAppHelper.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Helper/MainAppHelper.cs	(revision 12261)
+++ /extensions/PiwigoLib/PiwigoUpload/Helper/MainAppHelper.cs	(revision 12262)
@@ -5,4 +5,5 @@
 
 using System.IO;
+using Com.Piwigo.Uploader.DTO;
 
 namespace Com.Piwigo.Uploader.Helper
@@ -15,4 +16,41 @@
         }
 
+        internal static System.Windows.Forms.TreeNode buildAlbumToNode(LocalAlbum aAlbum)
+        {
+            System.Windows.Forms.TreeNode aNode = new System.Windows.Forms.TreeNode(aAlbum.Name,1,1);
+            aNode.ToolTipText = aAlbum.LocalDir;
+            aNode.Tag = aAlbum;
+
+            foreach (LocalImage Img in aAlbum.LocalImages)
+            {
+                System.Windows.Forms.TreeNode imgNode = new System.Windows.Forms.TreeNode(Img.Name, 2, 2);
+                imgNode.ToolTipText = Img.LocalFile;
+                imgNode.Tag = Img;
+                aNode.Nodes.Add(imgNode);
+            }
+
+            foreach (LocalAlbum Alb in aAlbum.SubAlbums)
+            {
+                aNode.Nodes.Add(buildAlbumToNode(Alb));
+            }
+
+            return aNode;
+        }
+
+        internal static void BuildAlbumTree(System.Windows.Forms.TreeView aTree, LocalAlbumList lstAlbum)
+        {
+            if (aTree.Nodes.Count > 0)
+            {
+                aTree.Nodes.Clear(); 
+            }
+
+            System.Windows.Forms.TreeNode root = new System.Windows.Forms.TreeNode("Albums", 0, 0);
+            aTree.Nodes.Add(root);
+            
+            foreach (LocalAlbum Alb in lstAlbum)
+	        {
+                root.Nodes.Add(buildAlbumToNode(Alb));
+	        }
+        }
 
         #region thumb
Index: /extensions/PiwigoLib/PiwigoUpload/MainForm.Designer.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/MainForm.Designer.cs	(revision 12261)
+++ /extensions/PiwigoLib/PiwigoUpload/MainForm.Designer.cs	(revision 12262)
@@ -31,9 +31,4 @@
         {
             this.components = new System.ComponentModel.Container();
-            System.Windows.Forms.TreeNode treeNode1 = new System.Windows.Forms.TreeNode("Node2");
-            System.Windows.Forms.TreeNode treeNode2 = new System.Windows.Forms.TreeNode("Node1", new System.Windows.Forms.TreeNode[] {
-            treeNode1});
-            System.Windows.Forms.TreeNode treeNode3 = new System.Windows.Forms.TreeNode("Root Category", new System.Windows.Forms.TreeNode[] {
-            treeNode2});
             System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
             this.button1 = new System.Windows.Forms.Button();
@@ -41,7 +36,9 @@
             this.label2 = new System.Windows.Forms.Label();
             this.label3 = new System.Windows.Forms.Label();
-            this.treeView1 = new System.Windows.Forms.TreeView();
+            this.AlbumsTV = new System.Windows.Forms.TreeView();
             this.imageListTV = new System.Windows.Forms.ImageList(this.components);
             this.cbxLstCatTo = new System.Windows.Forms.ComboBox();
+            this.modelManagerBaseBindingSource = new System.Windows.Forms.BindingSource(this.components);
+            this.selectedPwgCategoryListBindingSource = new System.Windows.Forms.BindingSource(this.components);
             this.label4 = new System.Windows.Forms.Label();
             this.button2 = new System.Windows.Forms.Button();
@@ -49,15 +46,16 @@
             this.tbServer = new System.Windows.Forms.TextBox();
             this.tbUser = new System.Windows.Forms.TextBox();
-            this.pwgCategoryListBindingSource = new System.Windows.Forms.BindingSource(this.components);
-            ((System.ComponentModel.ISupportInitialize)(this.pwgCategoryListBindingSource)).BeginInit();
+            this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
+            ((System.ComponentModel.ISupportInitialize)(this.modelManagerBaseBindingSource)).BeginInit();
+            ((System.ComponentModel.ISupportInitialize)(this.selectedPwgCategoryListBindingSource)).BeginInit();
+            this.tableLayoutPanel1.SuspendLayout();
             this.SuspendLayout();
             // 
             // button1
             // 
-            this.button1.Location = new System.Drawing.Point(273, 63);
+            resources.ApplyResources(this.button1, "button1");
+            this.button1.MaximumSize = new System.Drawing.Size(200, 20);
+            this.button1.MinimumSize = new System.Drawing.Size(75, 20);
             this.button1.Name = "button1";
-            this.button1.Size = new System.Drawing.Size(138, 23);
-            this.button1.TabIndex = 40;
-            this.button1.Text = "Telecharger";
             this.button1.UseVisualStyleBackColor = true;
             this.button1.Click += new System.EventHandler(this.Connect_Click);
@@ -65,49 +63,26 @@
             // label1
             // 
-            this.label1.AutoSize = true;
-            this.label1.Location = new System.Drawing.Point(12, 40);
+            resources.ApplyResources(this.label1, "label1");
             this.label1.Name = "label1";
-            this.label1.Size = new System.Drawing.Size(29, 13);
-            this.label1.TabIndex = 20;
-            this.label1.Text = "User";
             // 
             // label2
             // 
-            this.label2.AutoSize = true;
-            this.label2.Location = new System.Drawing.Point(217, 40);
+            resources.ApplyResources(this.label2, "label2");
             this.label2.Name = "label2";
-            this.label2.Size = new System.Drawing.Size(53, 13);
-            this.label2.TabIndex = 30;
-            this.label2.Text = "Password";
             // 
             // label3
             // 
-            this.label3.AutoSize = true;
-            this.label3.Location = new System.Drawing.Point(12, 14);
+            resources.ApplyResources(this.label3, "label3");
             this.label3.Name = "label3";
-            this.label3.Size = new System.Drawing.Size(38, 13);
-            this.label3.TabIndex = 10;
-            this.label3.Text = "Server";
-            // 
-            // treeView1
-            // 
-            this.treeView1.ImageIndex = 0;
-            this.treeView1.ImageList = this.imageListTV;
-            this.treeView1.Location = new System.Drawing.Point(15, 103);
-            this.treeView1.Name = "treeView1";
-            treeNode1.Name = "Node2";
-            treeNode1.SelectedImageIndex = 2;
-            treeNode1.Text = "Node2";
-            treeNode2.ImageIndex = 1;
-            treeNode2.Name = "Node1";
-            treeNode2.Text = "Node1";
-            treeNode3.Name = "RootCategory";
-            treeNode3.Text = "Root Category";
-            treeNode3.ToolTipText = "Root";
-            this.treeView1.Nodes.AddRange(new System.Windows.Forms.TreeNode[] {
-            treeNode3});
-            this.treeView1.SelectedImageIndex = 0;
-            this.treeView1.Size = new System.Drawing.Size(396, 202);
-            this.treeView1.TabIndex = 41;
+            // 
+            // AlbumsTV
+            // 
+            this.tableLayoutPanel1.SetColumnSpan(this.AlbumsTV, 4);
+            resources.ApplyResources(this.AlbumsTV, "AlbumsTV");
+            this.AlbumsTV.ImageList = this.imageListTV;
+            this.AlbumsTV.MinimumSize = new System.Drawing.Size(150, 150);
+            this.AlbumsTV.Name = "AlbumsTV";
+            this.AlbumsTV.Nodes.AddRange(new System.Windows.Forms.TreeNode[] {
+            ((System.Windows.Forms.TreeNode)(resources.GetObject("AlbumsTV.Nodes")))});
             // 
             // imageListTV
@@ -121,29 +96,32 @@
             // cbxLstCatTo
             // 
-            this.cbxLstCatTo.DataSource = this.pwgCategoryListBindingSource;
-            this.cbxLstCatTo.DisplayMember = "Name";
+            this.tableLayoutPanel1.SetColumnSpan(this.cbxLstCatTo, 2);
+            this.cbxLstCatTo.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.modelManagerBaseBindingSource, "PwgCategoryIdSelected", true));
+            this.cbxLstCatTo.DataSource = this.selectedPwgCategoryListBindingSource;
+            this.cbxLstCatTo.DisplayMember = "ShowedValue";
+            resources.ApplyResources(this.cbxLstCatTo, "cbxLstCatTo");
             this.cbxLstCatTo.FormattingEnabled = true;
-            this.cbxLstCatTo.Location = new System.Drawing.Point(47, 311);
             this.cbxLstCatTo.Name = "cbxLstCatTo";
-            this.cbxLstCatTo.Size = new System.Drawing.Size(223, 21);
-            this.cbxLstCatTo.TabIndex = 42;
             this.cbxLstCatTo.ValueMember = "Id";
             // 
+            // modelManagerBaseBindingSource
+            // 
+            this.modelManagerBaseBindingSource.DataSource = typeof(Com.Piwigo.Uploader.DTO.ModelManager.ModelManagerBase);
+            // 
+            // selectedPwgCategoryListBindingSource
+            // 
+            this.selectedPwgCategoryListBindingSource.DataSource = typeof(Com.Piwigo.Uploader.DTO.SelectedPwgCategoryList);
+            // 
             // label4
             // 
-            this.label4.AutoSize = true;
-            this.label4.Location = new System.Drawing.Point(12, 319);
+            resources.ApplyResources(this.label4, "label4");
             this.label4.Name = "label4";
-            this.label4.Size = new System.Drawing.Size(22, 13);
-            this.label4.TabIndex = 43;
-            this.label4.Text = "to :";
             // 
             // button2
             // 
-            this.button2.Location = new System.Drawing.Point(273, 314);
+            resources.ApplyResources(this.button2, "button2");
+            this.button2.MaximumSize = new System.Drawing.Size(200, 20);
+            this.button2.MinimumSize = new System.Drawing.Size(75, 20);
             this.button2.Name = "button2";
-            this.button2.Size = new System.Drawing.Size(138, 23);
-            this.button2.TabIndex = 44;
-            this.button2.Text = "Telecharger";
             this.button2.UseVisualStyleBackColor = true;
             this.button2.Click += new System.EventHandler(this.Telecharger_Click);
@@ -152,18 +130,16 @@
             // 
             this.tbPassword.DataBindings.Add(new System.Windows.Forms.Binding("Text", global::Com.Piwigo.Uploader.Properties.Settings.Default, "pwdData", true, System.Windows.Forms.DataSourceUpdateMode.OnPropertyChanged));
-            this.tbPassword.Location = new System.Drawing.Point(273, 37);
+            resources.ApplyResources(this.tbPassword, "tbPassword");
+            this.tbPassword.MinimumSize = new System.Drawing.Size(100, 20);
             this.tbPassword.Name = "tbPassword";
-            this.tbPassword.PasswordChar = '*';
-            this.tbPassword.Size = new System.Drawing.Size(138, 20);
-            this.tbPassword.TabIndex = 31;
             this.tbPassword.Text = global::Com.Piwigo.Uploader.Properties.Settings.Default.pwdData;
             // 
             // tbServer
             // 
+            this.tableLayoutPanel1.SetColumnSpan(this.tbServer, 3);
             this.tbServer.DataBindings.Add(new System.Windows.Forms.Binding("Text", global::Com.Piwigo.Uploader.Properties.Settings.Default, "serverUrlData", true, System.Windows.Forms.DataSourceUpdateMode.OnPropertyChanged));
-            this.tbServer.Location = new System.Drawing.Point(68, 11);
+            resources.ApplyResources(this.tbServer, "tbServer");
+            this.tbServer.MinimumSize = new System.Drawing.Size(100, 20);
             this.tbServer.Name = "tbServer";
-            this.tbServer.Size = new System.Drawing.Size(343, 20);
-            this.tbServer.TabIndex = 11;
             this.tbServer.Text = global::Com.Piwigo.Uploader.Properties.Settings.Default.serverUrlData;
             // 
@@ -171,36 +147,37 @@
             // 
             this.tbUser.DataBindings.Add(new System.Windows.Forms.Binding("Text", global::Com.Piwigo.Uploader.Properties.Settings.Default, "userData", true, System.Windows.Forms.DataSourceUpdateMode.OnPropertyChanged));
-            this.tbUser.Location = new System.Drawing.Point(68, 37);
+            resources.ApplyResources(this.tbUser, "tbUser");
+            this.tbUser.MinimumSize = new System.Drawing.Size(100, 20);
             this.tbUser.Name = "tbUser";
-            this.tbUser.Size = new System.Drawing.Size(138, 20);
-            this.tbUser.TabIndex = 21;
             this.tbUser.Text = global::Com.Piwigo.Uploader.Properties.Settings.Default.userData;
             // 
-            // pwgCategoryListBindingSource
-            // 
-            this.pwgCategoryListBindingSource.AllowNew = false;
-            this.pwgCategoryListBindingSource.DataSource = typeof(Com.Piwigo.Uploader.DTO.PwgCategoryList);
+            // tableLayoutPanel1
+            // 
+            resources.ApplyResources(this.tableLayoutPanel1, "tableLayoutPanel1");
+            this.tableLayoutPanel1.Controls.Add(this.button2, 3, 5);
+            this.tableLayoutPanel1.Controls.Add(this.label1, 0, 1);
+            this.tableLayoutPanel1.Controls.Add(this.label4, 0, 5);
+            this.tableLayoutPanel1.Controls.Add(this.tbServer, 1, 0);
+            this.tableLayoutPanel1.Controls.Add(this.tbUser, 1, 1);
+            this.tableLayoutPanel1.Controls.Add(this.label2, 2, 1);
+            this.tableLayoutPanel1.Controls.Add(this.AlbumsTV, 0, 3);
+            this.tableLayoutPanel1.Controls.Add(this.tbPassword, 3, 1);
+            this.tableLayoutPanel1.Controls.Add(this.button1, 3, 2);
+            this.tableLayoutPanel1.Controls.Add(this.label3, 0, 0);
+            this.tableLayoutPanel1.Controls.Add(this.cbxLstCatTo, 1, 5);
+            this.tableLayoutPanel1.Name = "tableLayoutPanel1";
             // 
             // MainForm
             // 
-            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+            resources.ApplyResources(this, "$this");
             this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-            this.ClientSize = new System.Drawing.Size(423, 346);
-            this.Controls.Add(this.button2);
-            this.Controls.Add(this.label4);
-            this.Controls.Add(this.cbxLstCatTo);
-            this.Controls.Add(this.treeView1);
-            this.Controls.Add(this.tbPassword);
-            this.Controls.Add(this.label3);
-            this.Controls.Add(this.tbServer);
-            this.Controls.Add(this.label2);
-            this.Controls.Add(this.label1);
-            this.Controls.Add(this.tbUser);
-            this.Controls.Add(this.button1);
+            this.Controls.Add(this.tableLayoutPanel1);
             this.Name = "MainForm";
-            this.Text = " Piwigo Uploader";
-            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.Form1_FormClosing);
-            this.Load += new System.EventHandler(this.Form1_Load);
-            ((System.ComponentModel.ISupportInitialize)(this.pwgCategoryListBindingSource)).EndInit();
+            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.MainForm_FormClosing);
+            this.Load += new System.EventHandler(this.MainForm_Load);
+            ((System.ComponentModel.ISupportInitialize)(this.modelManagerBaseBindingSource)).EndInit();
+            ((System.ComponentModel.ISupportInitialize)(this.selectedPwgCategoryListBindingSource)).EndInit();
+            this.tableLayoutPanel1.ResumeLayout(false);
+            this.tableLayoutPanel1.PerformLayout();
             this.ResumeLayout(false);
             this.PerformLayout();
@@ -217,10 +194,12 @@
         private System.Windows.Forms.TextBox tbServer;
         private System.Windows.Forms.TextBox tbPassword;
-        private System.Windows.Forms.TreeView treeView1;
+        private System.Windows.Forms.TreeView AlbumsTV;
         private System.Windows.Forms.ImageList imageListTV;
         private System.Windows.Forms.ComboBox cbxLstCatTo;
         private System.Windows.Forms.Label label4;
         private System.Windows.Forms.Button button2;
-        private System.Windows.Forms.BindingSource pwgCategoryListBindingSource;
+        private System.Windows.Forms.TableLayoutPanel tableLayoutPanel1;
+        private System.Windows.Forms.BindingSource selectedPwgCategoryListBindingSource;
+        private System.Windows.Forms.BindingSource modelManagerBaseBindingSource;
     }
 }
Index: /extensions/PiwigoLib/PiwigoUpload/MainForm.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/MainForm.cs	(revision 12261)
+++ /extensions/PiwigoLib/PiwigoUpload/MainForm.cs	(revision 12262)
@@ -17,7 +17,9 @@
         {
             InitializeComponent();
+            selectedPwgCategoryListBindingSource.DataSource = ModelManager.Instance.lstCat;
+            modelManagerBaseBindingSource.DataSource = ModelManager.Instance;
         }
 
-        private void Form1_Load(object sender, EventArgs e)
+        private void MainForm_Load(object sender, EventArgs e)
         {
             string[] args = Environment.GetCommandLineArgs();
@@ -38,4 +40,7 @@
                 }                    
             }
+
+            MainAppHelper.BuildAlbumTree(AlbumsTV, ModelManager.Instance.lstAlbumLocaux);
+
         }
 
@@ -46,4 +51,8 @@
             {
                 String strUri= tbServer.Text.Replace("\\","/");
+                if (!strUri.StartsWith("http"))
+                {
+                    strUri = "http://" + strUri;
+                }
                 if (!strUri.EndsWith("/ws.php"))
                 {
@@ -76,34 +85,5 @@
             try
             {
-
-                Int32 newid = 0;
-                String msg = String.Empty;
-                Boolean rc;
-                // rc = PwgServiceProvider.Instance.PwgCategoriesService.AddCategory("test_cat", 1, ref  newid, ref msg);
-                //List<PwgCategory> lstCat = PwgServiceProvider.Instance.PwgCategoriesService.GetAdminListOfCategory(); 
-                //Console.WriteLine(String.Format("newid : {0} message : {1}", newid,msg));
-                //rc = PwgServiceProvider.Instance.PwgCategoriesService.UpdateCategoryInfo(newid, "test2", "rename cat");
-                //Boolean rc = PwgServiceProvider.Instance.PwgCategoriesService.DeleteCategory(newid, sess.SecurityToken, PwgCategoryPhotoDeletionModeEnum.None);
-                //rc = PwgServiceProvider.Instance.PwgCategoriesService.MoveCategory(new List<Int32>() { newid }, PwgCategory.RootCategoryId, sess.SecurityToken);
-
-                //lstCat = PwgServiceProvider.Instance.PwgCategoriesService.GetAdminListOfCategory(); 
-
-                //FileInfo fiBig = new FileInfo("C:\\Users\\bayral\\Downloads\\49133_1636405570_2648232_n.jpg");
-                //FileInfo fiThumb = new FileInfo(MakeThumb(fiBig, "C:\\Users\\bayral\\Downloads\\49133_1636405570_2648232_n_thum.jpg", 64));
-                //FileInfo fiLow = new FileInfo(MakeThumb(fiBig, "C:\\Users\\bayral\\Downloads\\49133_1636405570_2648232_n_low.jpg", 256));
-
-                //FileInfo fiBig = new FileInfo("C:\\temp\\Oryx.jpg");
-                //FileInfo fiThumb = new FileInfo(MakeThumb(fiBig, "C:\\temp\\Oryx_thumb.jpg", 64));
-                //FileInfo fiLow = new FileInfo(MakeThumb(fiBig, "C:\\temp\\Oryx_low.jpg", 256));
-
-                //PwgImageAdded imgAdd = PwgServiceProvider.Instance.PwgImagesService.addImageByMultiPartForm(fiBig, null, 1, "benoit", "byarl", "test upload", 0, new List<PwgTag>() { new PwgTag() { Name = "Benoit" }, new PwgTag() { Name = "Noé" } });
-                //rc = PwgServiceProvider.Instance.PwgImagesService.addImage(fiBig, fiLow, fiThumb, "Benoit", "bayral", DateTime.Now, "demo", new List<string>() { "1" }, new List<string>() { "Benoit" }, PwgConfidentLevelEnum.All);
-                //rc = PwgServiceProvider.Instance.PwgImagesService.DeleteImage(319, sess.SecurityToken);
-
-                //PwgImageInfo info = PwgServiceProvider.Instance.PwgImagesService.getImageInfo(imgAdd.Id, null, null);
-
-                //PwgImageRate imgRate = PwgServiceProvider.Instance.PwgImagesService.RateImage(1, 5);
-
-
+                ServiceFactory.GetByType<UploadToPiwigo>().runService();
             }
             catch (ApplicationException aex)
@@ -113,5 +93,5 @@
         }
 
-        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
+        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
         {
             try
